char page_before ;
char language=1;
#define ENABLE_ENG_BIG        1 
#define ENABLE_ENG_SMALL      2 
#define ENABLE_ENG_SYMBOL     3    
#define ENABLE_FA_PAGE1       4
#define ENABLE_FA_PAGE2       5
#define ENABLE_FA_SYMBOL      6


typedef struct {
  int xPos, yPos, xSize, ySize;
  const char * acLabel;
  void (* pfDraw)(WM_HWIN hWin);
} BUTTON_DATA;

static const BUTTON_DATA _CharEngBig[] = {
  {   6,   6,  24, 24, "Q" },
  {  32,   6,  24, 24, "W" },
  {  58,   6,  24, 24, "E" },
  {  84,   6,  24, 24, "R" },
  { 110,   6,  24, 24, "T" },
  { 136,   6,  24, 24, "Y" },
  { 162,   6,  24, 24, "U" },
  { 188,   6,  24, 24, "I" },
  { 214,   6,  24, 24, "O" },
  { 240,   6,  24, 24, "P" },
  { 266,   6,  24, 24, "A" },
  { 292,   6,  24, 24, "S"},
  {  16,  34,  24, 24, "D" },
  {  42,  34,  24, 24, "F" },
  {  68,  34,  24, 24, "G" },
  {  94,  34,  24, 24, "H" },
  { 120,  34,  24, 24, "J" },
  { 120,  34,  24, 24, "K" },
  { 146,  34,  24, 24, "L" },
  { 172,  34,  24, 24, "Z" },
  { 198,  34,  24, 24, "X" },
  { 224,  34,  24, 24, "C" },
  { 250,  34,  24, 24, "V" },
  { 276,  34,  40, 24, "B"},
  {   6,  62,  24, 24, "N" },
  {  32,  62,  24, 24, "M" },
};

static const BUTTON_DATA _CharEngSmall[] = {
  {   6,   6,  24, 24, "q" },
  {  32,   6,  24, 24, "w" },
  {  58,   6,  24, 24, "e" },
  {  84,   6,  24, 24, "r" },
  { 110,   6,  24, 24, "t" },
  { 136,   6,  24, 24, "y" },
  { 162,   6,  24, 24, "u" },
  { 188,   6,  24, 24, "i" },
  { 214,   6,  24, 24, "o" },
  { 240,   6,  24, 24, "p" },
  { 266,   6,  24, 24, "a" },
  { 292,   6,  24, 24, "s" },
  {  16,  34,  24, 24, "d" },
  {  42,  34,  24, 24, "f" },
  {  68,  34,  24, 24, "g" },
  {  94,  34,  24, 24, "h" },
  { 120,  34,  24, 24, "j" },
  { 146,  34,  24, 24, "k" },
  { 172,  34,  24, 24, "l" },
  { 198,  34,  24, 24, "z" },
  { 224,  34,  24, 24, "x" },
  { 250,  34,  24, 24, "c" },
  { 276,  34,  40, 24, "v" },
  {   6,  62,  24, 24, "b" },
  {  32,  62,  24, 24, "n" },
  {  58,  62,  24, 24, "m" },
};

static const BUTTON_DATA _CharEngSymbol[] = {
  {   6,   6,  24, 24, "1" },
  {  32,   6,  24, 24, "2" },
  {  58,   6,  24, 24, "3" },
  {  84,   6,  24, 24, "4" },
  { 110,   6,  24, 24, "5" },
  { 136,   6,  24, 24, "6" },
  { 162,   6,  24, 24, "7" },
  { 188,   6,  24, 24, "8" },
  { 214,   6,  24, 24, "9" },
  { 240,   6,  24, 24, "0" },
  { 266,   6,  24, 24, "$" },
  { 292,   6,  24, 24, "@" },
  {  16,  34,  24, 24, "*" },
  {  42,  34,  24, 24, "+" },
  {  68,  34,  24, 24, "-" },
  {  94,  34,  24, 24, "=" },
  { 120,  34,  24, 24, "/" },
  { 146,  34,  24, 24, "(" },
  { 172,  34,  24, 24, ")" },
  { 198,  34,  24, 24, "!" },
  { 224,  34,  24, 24, "?" },
  { 250,  34,  24, 24, ":" },
  { 276,  34,  40, 24, ";" },
  {   6,  62,  24, 24, "%" },
  {  32,  62,  24, 24, "[" },
  {  58,  62,  24, 24, "]" },
};

static const BUTTON_DATA _CharFaP1[] = {
  {   6,   6,  24, 24, "\xd8\xb6" },// Initialization of 'ZAAD'     Q
  {  32,   6,  24, 24, "\xd8\xb5" },// Initialization of 'SAAD'     W
  {  58,   6,  24, 24, "\xd9\x82" },// Initialization of 'GHE'      E
  {  84,   6,  24, 24, "\xd9\x81" },// Initialization of 'FE'       R
  { 110,   6,  24, 24, "\xd8\xba" },// Initialization of 'GHEIN'    T
  { 136,   6,  24, 24, "\xd8\xb9" },// Initialization of 'EEIN'     Y
  { 162,   6,  24, 24, "\xd9\x87" },// Initialization of 'HE'       U
  { 188,   6,  24, 24, "\xd8\xae" },// Initialization of 'KHE'      I
  { 214,   6,  24, 24, "\xd8\xad" },// Initialization of 'HEEE'     O
  { 240,   6,  24, 24, "\xd8\xac" },// Initialization of 'JIM '     P
  { 266,   6,  24, 24, "\xd8\xb4" },// Initialization of 'SHIN'     A
  { 292,   6,  24, 24, "\xd8\xb3" },// Initialization of 'SIN'      S
  {  16,  34,  24, 24, "\xdb\x8c" },// Initialization of 'YEE'      D 
  {  42,  34,  24, 24, "\xd8\xa8" },// Initialization of 'BE'       F
  {  68,  34,  24, 24, "\xd9\x84" },// Initialization of 'LAAM'     G
  {  94,  34,  24, 24, "\xd8\xa7" },// Initialization of 'ALEF'     H
  { 120,  34,  24, 24, "\xd8\xaa" },// Initialization of 'TE'       J
  { 120,  34,  24, 24, "\xd9\x86" },// Initialization of 'NOON'     K
  { 146,  34,  24, 24, "\xd9\x85" },// Initialization of 'MIM'      L                            
  { 172,  34,  24, 24, "\xd8\xb7" },// Initialization of 'TAA'      Z
  { 198,  34,  24, 24, "\xd8\xb2" },// Initialization of 'ZE'       X
  { 224,  34,  24, 24, "\xd8\xb1" },// Initialization of 'RE'       C
  { 250,  34,  24, 24, "\xd8\xaf" },// Initialization of 'DAAL'     V
  { 276,  34,  40, 24, "\xd9\x88" },// Initialization of 'VAAV'     B
  {   6,  62,  24, 24, "\xda\xa9" },// Initialization of 'GAAF'     N
  {  32,  62,  24, 24, "\xda\xaf" },// Initialization of 'KAAF'     M
};

static const BUTTON_DATA _CharFaP2[] = {
  {   6,   6,  24, 24, "\xd8\xa2" },
  {  32,   6,  24, 24, "" },
  {  58,   6,  24, 24, "" },
  {  84,   6,  24, 24, "" },
  { 110,   6,  24, 24, "" },
  { 136,   6,  24, 24, "" },
  { 162,   6,  24, 24, "" },
  { 188,   6,  24, 24, "" },
  { 214,   6,  24, 24, "" },
  { 240,   6,  24, 24, "\xda\x86" },// Initialization of 'CHE'
  { 266,   6,  24, 24, "" },
  { 292,   6,  24, 24, ""},
  {  16,  34,  24, 24, "\xd8\xa6" }, // Initialization of 'YE HAMZE' D
  {  42,  34,  24, 24, "\xd9\xbe" },// Initialization of 'PE'    F
  {  68,  34,  24, 24, "\xd8\xab" },  // Initialization of 'SE SE DOT' G
  {  94,  34,  24, 24, "\xd8\xa2" },  // Initialization of 'AA BA HAT'   H
  { 120,  34,  24, 24, "" },
  {120,  34,  24, 24, ""  },
  { 146,  34,  24, 24, "" },
  { 172,  34,  24, 24, "\xd8\xb8" },    // Initialization of 'ZAA'  Z
  { 198,  34,  24, 24, "\xda\x98" },// Initialization of 'JHE SE DOT'  X
  { 224,  34,  24, 24, "" },
  { 250,  34,  24, 24, "\xd8\xb0" },// Initialization of 'ZAAL'  V
  { 276,  34,  40, 24, ""},
  {   6,  62,  24, 24, "" },
  {  32,  62,  24, 24, "" },
};

static const BUTTON_DATA _CharFaSymbol[] = {
  {   6,   6,  24, 24, "\xdb\xb1" },
  {  32,   6,  24, 24, "\xdb\xb2" },
  {  58,   6,  24, 24, "\xdb\xb3" },
  {  84,   6,  24, 24, "\xdb\xb4" },
  { 110,   6,  24, 24, "\xdb\xb5" },
  { 136,   6,  24, 24, "\xdb\xb6" },
  { 162,   6,  24, 24, "\xdb\xb7" },
  { 188,   6,  24, 24, "\xdb\xb8" },
  { 214,   6,  24, 24, "\xdb\xb9" },
  { 240,   6,  24, 24, "\xdb\xb0" },
  { 266,   6,  24, 24, "\xd9\x80" },// -
  { 292,   6,  24, 24, "\xd8\x8c"},//"،", 
  {  16,  34,  24, 24, "*" },
  {  42,  34,  24, 24, "+" },
  {  68,  34,  24, 24, "-" },
  {  94,  34,  24, 24, "=" },
  { 120,  34,  24, 24, "/" },
  { 146,  34,  24, 24, "(" },
  { 172,  34,  24, 24, ")" },
  { 198,  34,  24, 24, "!" },
  { 224,  34,  24, 24, "\xd8\x9f" },//"؟"
  { 250,  34,  24, 24, ":" },
  { 276,  34,  40, 24, "\xd8\x9b" },//"؛"
  {   6,  62,  24, 24, "%" },
  {  32,  62,  24, 24, "[" },
  {  58,  62,  24, 24, "]" },
};




static int _C_CHAR_FA_P1[] = //horof farsi baraye kamel
{1590,1589,1602,1601,1594,1593,1607,1582,1581,1580,1588,1587,1610,1576,1604,1575,1578,1606,1605,1591,1586,1585,1583,1608,1603,1711};

 static int _C_CHAR_FA_P2[] =  //horof farsi baraye edame farsi
{1570,0000,0000,0000,0000,0000,0000,0000,0000,1670,0000,0000,1574,1662,1579,1570,0000,0000,0000,1592,1688,0000,1584,0000,0000,0000};

 static int _C_CHAR_FA_SYMBOL[] = 
{1777,1778,1779,1780,1781,1782,1783,1784,1785,1776,45,1548,215,43,45,61,47,41,40,33,1567,58,1563,37,123,125};

void keyboard_order_key_ENG(WM_HWIN hkeyboard,char page);
void keyboard_order_key_FA(WM_HWIN  hkeyboard,char page);
void keyboard_order_key_SHIFT(WM_HWIN hkeyboard);
void keyboard_order_key_symbol(WM_HWIN hkeyboard );



void keyboard_order_key_ENG(WM_HWIN hkeyboard, char page)
{WM_HWIN hItem;
 int i;
 hItem = WM_GetDialogItem(hkeyboard,ID_MULTIEDIT_0);
 MULTIEDIT_SetTextAlign(hItem, GUI_TA_LEFT );//| GUI_TA_VCENTER);
 MULTIEDIT_SetFont(hItem, &GUI_FontArabic24);
 

	  if (page==1) language=ENABLE_ENG_BIG;
	  if (page==2) language=ENABLE_ENG_SMALL; 
 for (i = 0; i <= 25; i++) 
	 {
	  hItem = WM_GetDialogItem(hkeyboard,ID_BUTTON_0+i);
	  BUTTON_SetFont(hItem, GUI_FONT_13_1);


	  if (page==1) BUTTON_SetText(hItem, _CharEngBig[i].acLabel);
	  if (page==2) BUTTON_SetText(hItem, _CharEngSmall[i].acLabel);
     }
}


void keyboard_order_key_FA (WM_HWIN  hkeyboard,char page) 
{WM_HWIN hItem;
 int i;

 GUI_UC_SetEncodeUTF8(); /* Enable UTF8 decoding */
 GUI_UC_EnableBIDI(1);   /* Enable bidirectional text */

 hItem = WM_GetDialogItem(hkeyboard,ID_MULTIEDIT_0);
 MULTIEDIT_SetTextAlign(hItem, GUI_TA_RIGHT );//| GUI_TA_VCENTER);
 MULTIEDIT_SetFont(hItem, &GUI_FontArabic24);



 	  if (page==1) language=ENABLE_FA_PAGE1;
      if (page==2) language=ENABLE_FA_PAGE2;
 for (i = 0; i <= 25; i++) 
	 {
	  hItem = WM_GetDialogItem(hkeyboard,ID_BUTTON_0+i);	
      BUTTON_SetFont(hItem, &GUI_FontB_Mitra24);


	  if      (page==1)  BUTTON_SetText(hItem, _CharFaP1[i].acLabel);
 	  else if (page==2)  BUTTON_SetText(hItem, _CharFaP2[i].acLabel);
	  
      }

}

void keyboard_order_key_symbol(WM_HWIN hkeyboard)
 {WM_HWIN hItem;
  char acBuffer[2];
  int i;



 


        if ((language==ENABLE_FA_PAGE1) || (language==ENABLE_ENG_BIG) ) 
		     {page_before=1;}
		else if ((language==ENABLE_FA_PAGE2) || (language==ENABLE_ENG_SMALL) )  
		     {page_before=2;};



  if (language==ENABLE_ENG_SYMBOL)   keyboard_order_key_ENG(hkeyboard ,page_before);
  else if (language==ENABLE_FA_SYMBOL)    keyboard_order_key_FA(hkeyboard ,page_before);

  else if ((language==ENABLE_FA_PAGE1) || (language==ENABLE_FA_PAGE2) ) 
    {  language= ENABLE_FA_SYMBOL;  
      for (i = 0; i <= 25; i++) 
	      {
	        hItem = WM_GetDialogItem(hkeyboard,ID_BUTTON_0+i);	
            BUTTON_SetFont(hItem, &GUI_FontB_Mitra24);
			BUTTON_SetText(hItem, _CharFaSymbol[i].acLabel);
          }
    }

  

  else if ((language==ENABLE_ENG_BIG) || (language==ENABLE_ENG_SMALL)) 
   {  
	   language=ENABLE_ENG_SYMBOL;
       for (i = 0; i <= 25; i++) 
	       {
	        hItem = WM_GetDialogItem(hkeyboard,ID_BUTTON_0+i);
	        BUTTON_SetFont(hItem, GUI_FONT_13_1);
			BUTTON_SetText(hItem,_CharEngSymbol[i].acLabel);
            }
   };

 }
void keyboard_order_key_SHIFT (WM_HWIN hkeyboard)
{

 if (language==ENABLE_ENG_BIG)   keyboard_order_key_ENG (hkeyboard ,2);
 else if (language==ENABLE_ENG_SMALL) keyboard_order_key_ENG (hkeyboard ,1);
 else if (language==ENABLE_FA_PAGE1)  keyboard_order_key_FA  (hkeyboard ,2);
 else if (language==ENABLE_FA_PAGE2)  keyboard_order_key_FA  (hkeyboard ,1);
 
 }